/***
 * Juliac
 * Copyright (C) 2012 Inria, Univ. Lille 1
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@ow2.org
 *
 * Author: Lionel Seinturier
 */

package org.objectweb.fractal.runtime.ultracomp;

import org.objectweb.fractal.api.Type;
import org.objectweb.fractal.koch.factory.MBindingControlComponent;

/**
 * Extend the implementation of {@link
 * org.objectweb.fractal.koch.factory.MPrimitiveImpl} with a support for
 * injecting the reference of the control-part into a binding control-component.
 * 
 * TODO move this class to koch-runtime
 * 
 * @author Lionel Seinturier <Lionel.Seinturier@univ-lille1.fr>
 * @see MBindingControlComponent
 * @since 2.5
 */
public class MPrimitiveImpl
extends org.objectweb.fractal.koch.factory.MPrimitiveImpl {

	public MPrimitiveImpl( Type type, Object content ) {
		
		super(type,content);
		
		if( content instanceof MBindingControlComponent ) {
			((MBindingControlComponent)content).setFcOwner(this);
		}
	}
}
